<%--
  Created by IntelliJ IDEA.
  User: Administrator
  Date: 2020/9/11
  Time: 12:54
  To change this template use File | Settings | File Templates.
--%>
<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="com.censoft.common.base.Pub" %>
<%@ page import="com.censoft.common.db.ConnectionFactory" %>
<%@ page import="java.sql.Connection" %>
<%@ page import="java.util.Hashtable" %>
<%@ page import="java.util.Vector" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.List" %>
<%
    ConnectionFactory cf = new ConnectionFactory();
    Pub pub = new Pub();
    String dept_id = pub.trimNull(request.getParameter("dept_id"));
    String seg_check_del = pub.trimNull(request.getParameter("seg"));
    String seg_end_check_del = pub.trimNull(request.getParameter("seg_end"));
    String input_count = pub.trimNull(request.getParameter("input_count"));
    if("".equals(input_count)){
        input_count="1";
    }
    int inputSize=Integer.parseInt(input_count);
    boolean flag = true;
    Vector v_list_p=null;
    Vector v_list;
    try (Connection conn = com.censoft.db.DBUtil.getRedConnection()) {
        int seg_order;
        String msg = "";
        if(!"".equals(seg_check_del)){
            String sql = "select phone  from tp_phone_info  where status != '0' and status != '3' and phone>=? and phone<=? ";
            Vector phone_list = cf.doQuery(conn, sql, null, new Object[]{seg_check_del,seg_end_check_del});
            if (phone_list != null && phone_list.size() > 0) {
                flag = false;
                msg = "号码段含有分配中或已分配号码";
            }
        }else{
            //验证父部门是否已经填写号码段，并验证本号码段是否符合父号码段往下兼容的效果。
            v_list_p = cf.doQuery(conn, "select p_id  from tp_dept  where id = ?", null, new Object[]{dept_id});
            Hashtable ht_p = (Hashtable)v_list_p.get(0);
            if(v_list_p != null && v_list_p.size() > 0 && !"".equals(((Hashtable)v_list_p.get(0)).get("p_id"))){
                v_list = cf.doQuery(conn, "select t1.seg,t1.seg_end  from tp_segment t1 join tp_dept t2 on t1.dept_id=t2.p_id   where t2.id = ?", null, new Object[]{dept_id});
                if (v_list != null && v_list.size() > 0) {
                    flag = false;
                    msg = "号码段前几位请参照上级部门的号码段输入";
                    Hashtable ht;
                    for (int j = 0; j < inputSize; j++) {
                        seg_order = j + 1;
                        String seg = pub.trimNull(request.getParameter("seg_" + seg_order));
                        String seg_end = pub.trimNull(request.getParameter("seg_end_" + seg_order));
                        if (!"".equals(seg)&&!"".equals(seg_end)) {
                            for (Object aV_list : v_list) {
                                ht = (Hashtable) aV_list;
                                if (!"".equals(ht.get("seg"))&&!"".equals(ht.get("seg_end"))) {
                                    int seg_b=Integer.parseInt(seg);
                                    int seg_e=Integer.parseInt(seg_end);
                                    int seg_p=Integer.parseInt(ht.get("seg") + "");
                                    int seg_end_p=Integer.parseInt(ht.get("seg_end") + "");
                                    if (seg_b>= seg_p && seg_e<=seg_end_p) {
                                        flag = true;
                                        msg = "";
                                        break;
                                    }else {
                                        flag = false;
                                        msg = "号码段前几位请参照上级部门的号码段输入";
                                    }
                                }
                            }
                            if(!flag){
                                break;
                            }
                        }
                    }
                } else {
                    flag = false;
                    msg = "请先设置上级部门的号码段";
                }
            }
            //验证新号码段是否被别的号码段占用status='1'为预占状态
            String p_id=(String) (ht_p.get("p_id"));
            List list = new ArrayList();
            StringBuffer sb = new StringBuffer();
            sb.append("select t1.seg,t1.seg_end  from tp_segment t1 join tp_dept t2 on t1.dept_id=t2.id " +
                    "where ((seg<=? and seg_end>=?) or  (seg<=? and seg_end>=?)) " +
                    "and t2.p_id=? and t1.status!='1' and t1.dept_id != ?");
            sb.append(" UNION select t1.seg,t1.seg_end  from tp_segment t1 " +
                    "where ((seg<=? and seg_end>=?) or  (seg<=? and seg_end>=?)) " +
                    "and t1.status='1' ");
            if (flag) {
                for (int i = 0; i < inputSize; i++) {
                    seg_order = i + 1;
                    String seg = pub.trimNull(request.getParameter("seg_" + seg_order));
                    String seg_end = pub.trimNull(request.getParameter("seg_end_" + seg_order));
                    if (!"".equals(seg)&&!"".equals(seg_end)) {
                        int seg_b=Integer.parseInt(seg);
                        int seg_e=Integer.parseInt(seg_end);
                        list.add(seg_b);
                        list.add(seg_b);
                        list.add(seg_e);
                        list.add(seg_e);
                        list.add(p_id);
                        list.add(dept_id);
                        list.add(seg_b);
                        list.add(seg_b);
                        list.add(seg_e);
                        list.add(seg_e);
                        //v_list = cf.doQuery(conn, "select t1.seg,t1.seg_end  from tp_segment t1 join tp_dept t2 on t1.dept_id=t2.id where ((seg<=? and seg_end>=?) or  (seg<=? and seg_end>=?)) and t2.p_id=? and t1.dept_id != ?", null, new Object[]{seg_b,seg_b,seg_e,seg_e, p_id,dept_id});
                        v_list = cf.doQuery(conn, sb.toString(), null, list.toArray());
                        if (v_list != null && v_list.size() > 0) {
                            flag = false;
                            msg = "新号码段已被占用";
                        }
                    }
                }
                //end


                //验证旧号码段是否有分配中和已分配的号码
                if (flag) {
                    Hashtable ht;
                    v_list = cf.doQuery(conn, "select seg,seg_end  from tp_segment   where dept_id = ?", null, new Object[]{dept_id});
                    if (v_list != null && v_list.size() > 0) {
                        for (Object aV_list : v_list) {
                            ht = (Hashtable) aV_list;
                            String seg = pub.trimNull(ht.get("seg") + "");
                            String seg_end = pub.trimNull(ht.get("seg_end") + "");
                            if (!"".equals(seg)&&!"".equals(seg_end)) {
                                int seg_b=Integer.parseInt(seg);
                                int seg_e=Integer.parseInt(seg_end);
                                //seg = "'"+seg + "%'";
                                String sql = "select phone  from tp_phone_info  where status != '0' and status != '3' and status != '4' and phone>=? and phone<=? ";
                                //String sql = "select phone  from tp_phone_info  where status != '0' and status != '3' and cast(phone as varchar(10)) like ？";
                                Vector phone_list = cf.doQuery(conn, sql, null, new Object[]{seg_b,seg_e});

                                if (phone_list != null && phone_list.size() > 0) {
                                    flag = false;
                                    msg = "原号码段含有分配中或已分配号码";
                                }
                            }
                        }
                    }
                }
                //end
            }
        }
        //Logger.log(conn,"号码段管理", "添加", dept_id, "", request);
        if (!flag) {
            out.println(msg);
            return;
        } else {
            out.println("success");
        }
        return;


    } catch (Exception e) {
        System.out.println("号码段检查异常" + e);
        return;
    }
%>