<%--
  Created by IntelliJ IDEA.
  User: Administrator
  Date: 2020/9/11
  Time: 12:54
  To change this template use File | Settings | File Templates.
--%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ page import="java.sql.Connection" %>
<%@ page import="java.util.*" %>
<%@ page import="com.censoft.common.db.ConnectionFactory" %>
<%@ page import="com.censoft.common.base.Pub" %>
<%!
    ConnectionFactory cf = new ConnectionFactory();
    Pub pub = new Pub();
    public Set<String> getAllDeptIdByPid(Connection conn,String deptPId){
        Vector allDeptList = cf.doQuery(conn, "select id,p_id  from tp_dept  ", null, new Object[]{});
        Map<String, List<String>> pMap = new HashMap<>();
        Set<String> set = new HashSet<>();
        if(allDeptList != null && allDeptList.size() > 0){
            for (Object o : allDeptList) {
                Hashtable ht = (Hashtable)o;
                String pId = ht.get("p_id") + "";
                String id = ht.get("id") + "";
                List<String> idList = pMap.get(pId);
                if(idList != null && idList.size() > 0){
                    idList.add(id);
                    pMap.put(pId,idList);
                }else{
                    idList = new ArrayList<>();
                    idList.add(id);
                    pMap.put(pId,idList);
                }
            }
            getDeptIdBy(pMap,deptPId,set);

        }
        return set;
    }
    private void getDeptIdBy(Map<String, List<String>> pMap,String deptPId,Set<String> set){
        List<String> strings = pMap.get(deptPId);
        set.add(deptPId);
        if(strings != null && strings.size() > 0){
            for (String string : strings) {
                getDeptIdBy(pMap,string,set);
                set.add(string);
            }
        }
    }
    public String getDeptIds(Set<String> pid_list,String dept_id){
        String deptIds="";
        if(pid_list != null && pid_list.size() > 0){
            for (String s : pid_list) {
                if (!dept_id.equals(s)) {
                    deptIds = deptIds + "'" + s + "',";
                }
            }
            if(!"".equals(deptIds)){
                deptIds = deptIds+"'"+dept_id+"'";
            }else{
                deptIds = "'"+dept_id+"'";
            }
        }else{
            deptIds = "'"+dept_id+"'";
        }
        return deptIds;
    }
    public String getDeptName(Connection conn,String dept_id){
        StringBuffer sql = new StringBuffer();
        String deptName="";
        sql.append("select t1.dept_name as dept_name_4,t2.dept_name as dept_name_3,t3.dept_name as dept_name_2,t4.dept_name as dept_name_1 from ");
        sql.append("tp_dept t1 left join tp_dept t2 on t1.p_id=t2.id");
        sql.append(" left join tp_dept t3 on t2.p_id=t3.id");
        sql.append(" left join tp_dept t4 on t3.p_id=t4.id");
        sql.append(" where t1.id=?");
        Vector v_list = cf.doQuery(conn, sql.toString(), null, new Object[]{dept_id});
        if(v_list!=null && v_list.size()>0){
            Hashtable ht = (Hashtable) v_list.get(0);
            String dept_name_4 = pub.trimNull((String) ht.get("dept_name_4"));
            String dept_name_3 = pub.trimNull((String) ht.get("dept_name_3"));
            String dept_name_2 = pub.trimNull((String) ht.get("dept_name_2"));
            String dept_name_1 = pub.trimNull((String) ht.get("dept_name_1"));
            if(!"".equals(dept_name_3)){
                deptName=dept_name_3+">"+dept_name_4;
            }else{
                deptName=dept_name_4;
            }
            if(!"".equals(dept_name_2)){
                deptName=dept_name_2+">"+dept_name_3+">"+dept_name_4;
            }
            if(!"".equals(dept_name_1)){
                deptName=dept_name_1+">"+dept_name_2+">"+dept_name_3+">"+dept_name_4;
            }
        }
        return deptName;
    }
%>
<%
    ConnectionFactory cf = new ConnectionFactory();
    Pub pub = new Pub();
    Connection conn = null;
    Vector v_list = null;
    String page_number = pub.trimNull(request.getParameter("page_number"));
    if ("".equals(page_number)) page_number = "1";
    String page_size = pub.trimNull(request.getParameter("page_size"));
    if ("".equals(page_size)) page_size = "10";
    String dept_name_search = pub.trimNull(request.getParameter("dept_name"));
    String seg_search = pub.trimNull(request.getParameter("seg"));
    String seg_end_search = pub.trimNull(request.getParameter("seg_end"));
    List list_s = new ArrayList();
    String deptIds="";
    try {
        StringBuffer sb = new StringBuffer();
        sb.append("select distinct t1.dept_name,t2.dept_id,t2.update_time,t1.id,t1.dept_order from tp_dept t1 join tp_segment t2 on t1.id = t2.dept_id where 1=1 ");
        if(!"".equals(dept_name_search)){
            sb.append(" and t1.dept_name like ?");
            list_s.add("%"+dept_name_search+"%");
        }
        if(!"".equals(seg_search)){
            sb.append(" and t2.seg >= ?");
            list_s.add(seg_search);
        }
		if(!"".equals(seg_end_search)){
            sb.append(" and t2.seg_end <= ?");
            list_s.add(seg_end_search);
        }
        sb.append("  order by t2.update_time desc,t1.id desc,t1.dept_order asc");
        conn = com.censoft.db.DBUtil.getRedConnection();
        v_list = cf.doPageQueryWithCount(conn, sb.toString(), page_number, page_size, null, list_s.toArray());
        if (v_list == null) {
            out.println("查询日志出错" + cf.getMsg());
            return;
        }
    } catch (Exception e) {
        out.println("查询日志出错异常" + e);
        return;
    } finally {
        if (conn != null) {
            try {
                conn.close();
            } catch (Exception e) {
            }
        }
    }
    Hashtable ht_row = (Hashtable) v_list.get(0);
    String rowCnt = pub.trimNull((String) ht_row.get("ROWCOUNT"));
    String pageCnt = pub.trimNull((String) ht_row.get("PAGECOUNT"));
    String telSegmentUrl="./seg_add-t.jsp";
%>
<div>
    <a class="btn btn-primary radius" onclick="telSegment('分配号段','<%=telSegmentUrl%>');" >
        分配号段
    </a>
</div>
<div class="table-list">
    <table class="table  table-hover table-bg">
        <thead>
        <tr class="text-c">
            <th width="30px">序号</th>
            <th width="150px">单位名称</th>
            <th width="200px">号码段</th>
            <th width="50px">操作</th>
        </tr>
        </thead>
        <tbody>
        <%
            if (v_list != null && v_list.size() > 0) {
                try {
                    Vector seg_list = null;
                    conn = com.censoft.db.DBUtil.getRedConnection();
                    for (int i = 1; i < v_list.size(); i++) {
                        Hashtable ht = (Hashtable) v_list.get(i);
                        String dept_name = pub.trimNull((String) ht.get("dept_name"));
                        String dept_id = pub.trimNull((String) ht.get("dept_id"));
                        dept_name=getDeptName(conn,dept_id);
                        //deptIds=getDeptIds(getAllDeptIdByPid(conn, dept_id),dept_id);
                        String seg = "";
                        String seg_sql = "select distinct seg,seg_end,seg_order from tp_segment where dept_id =? order by seg asc";
                        seg_list = cf.doQuery(conn, seg_sql,  null, new Object[]{dept_id});
                        // select cast(seg as char) seg from tp_segment
                        if(seg_list != null && seg_list.size() > 0){
                            for (int j = 0; j < seg_list.size(); j++) {
                                Hashtable ht_seg = (Hashtable) seg_list.get(j);
                                if(!"".equals(ht_seg.get("seg"))&&!"".equals(ht_seg.get("seg_end"))){
                                    seg += ht_seg.get("seg") + "-"+ht_seg.get("seg_end")+"</br>";
                                }

                            }
                            if(seg.length() > 0){
                                seg = seg.substring(0,seg.length()-1);
                            }

                        }
                        %>
                        <tr <%if(i%2==0){%>id="tr_doub"<%}else{%>id="tr_single"<%}%> class="text-c">
                            <td><%=i%>
                            </td>
                            <td><%=dept_name%>
                            </td>
                            <td><%=seg%>
                            </td>
                            <td>
                                <a title="编辑" href="javascript:void(0);" onclick="edit_seg('<%=dept_id%>');" class="ml-5" >
                                    <i class="Hui-iconfont">编辑</i>
                                </a>
                            </td>
                        </tr>
                        <%

                    }

                } catch (Exception e) {
                    out.println("查询日志出错异常" + e);
                    return;
                } finally {
                    if (conn != null) {
                        try {
                            conn.close();
                        } catch (Exception e) {
                        }
                    }
                }
            }
        %>
        </tbody>
    </table>
</div>
<jsp:include page="/common/page_ajax.jsp" >
    <jsp:param name="page_number" value="<%=page_number%>" />
    <jsp:param name="rowCnt" value="<%=rowCnt%>" />
    <jsp:param name="page_size" value="<%=page_size%>" />
</jsp:include>